KParts::Part class Reference (kparts Library)

| # kparts Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KParts::Part Class Reference

Base class for parts. More...

`#include <part.h>`

Inheritance diagram for KParts::Part:

[legend]
Collaboration diagram for KParts::Part:

[legend]
List of all members.

## Signals
void | setWindowCaption (const QString &caption)
| Emitted by the part, to set the caption of the window(s) hosting this part.
void | setStatusBarText (const QString &text)
| Emited by the part, to set a text in the statusbar of the window(s) hosting this part.
## Public Member Functions
| Part (QObject *parent=0, const char *name=0)
| Constructor.
virtual | ~Part ()
| Destructor.
virtual void | embed (QWidget *parentWidget)
| Embed this part into a host widget.
virtual QWidget * | widget ()
virtual void | setManager (PartManager *manager)
PartManager * | manager () const
| Returns the part manager handling this part, if any (0L otherwise).
virtual Part * | hitTest (QWidget *widget, const QPoint &globalPos)
virtual void | setSelectable (bool selectable)
bool | isSelectable () const
| Returns whether the part is selectable or not.
## Protected Member Functions
virtual void | setWidget (QWidget *widget)
| Set the main widget.
virtual void | customEvent (QCustomEvent *event)
virtual void | partActivateEvent (PartActivateEvent *event)
| Convenience method which is called when the Part received a PartActivateEvent .
virtual void | partSelectEvent (PartSelectEvent *event)
| Convenience method which is called when the Part received a PartSelectEvent .
virtual void | guiActivateEvent (GUIActivateEvent *event)
| Convenience method which is called when the Part received a GUIActivateEvent .
QWidget * | hostContainer (const QString &containerName)
| Convenience method for KXMLGUIFactory::container.

## Detailed Description

Base class for parts.

A "part" is a GUI component, featuring:

- A widget embeddedable in any application.
- GUI elements that will be merged in the "host" user interface (menubars, toolbars... ).

About the widget Note that KParts::Part does not inherit QWidget. This is due to the fact that the "visual representation" will probably not be a mere QWidget, but an elaborate one. That's why when implementing your KParts::Part (or derived) you should call KParts::Part::setWidget() in your constructor.

About the GUI elements Those elements trigger actions, defined by the part (action()). The layout of the actions in the GUI is defined by an XML file (setXMLFile()).

See also ReadOnlyPart and ReadWritePart, which define the framework for a "viewer" part and for an "editor"-like part. Use Part directly only if your part doesn't fit into those.

Definition at line 142 of file part.h.

## Constructor & Destructor Documentation

Part::Part | ( | QObject * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructor. Parameters:
  parent | Parent object of the part.
  name | QT-internal name of the part.
Definition at line 131 of file part.cpp. References KStdAccel::name().

Part::~Part | ( |  | ) | `[virtual]`

| Destructor. Definition at line 140 of file part.cpp. References QObject::destroyed(), QObject::disconnect(), and KParts::PartManager::removePart().

## Member Function Documentation

void Part::embed | ( | QWidget * | parentWidget | ) | `[virtual]`

| Embed this part into a host widget. You don't need to do this if you created the widget with the correct parent widget - this is just a QWidget::reparent(). Note that the Part is still the holder of the QWidget, meaning that if you delete the Part, then the widget gets destroyed as well, and vice-versa. This method is not recommended since creating the widget with the correct parent is simpler anyway. Definition at line 163 of file part.cpp. References QWidget::reparent(), and widget().

QWidget * Part::widget | ( |  | ) | `[virtual]`

| Returns: The widget defined by this part, set by setWidget(). Definition at line 169 of file part.cpp. Referenced by KParts::PartManager::addPart(), embed(), KParts::ReadWritePart::queryClose(), KParts::PartManager::setActivePart(), and KParts::PartManager::setSelectedPart().

PartManager * Part::manager | ( |  | ) | const

| Returns the part manager handling this part, if any (0L otherwise). Definition at line 179 of file part.cpp.

void Part::setSelectable | ( | bool | selectable | ) | `[virtual]`

  | Parameters:
  selectable | Indicates whether the part is selectable or not.
Definition at line 209 of file part.cpp.

bool Part::isSelectable | ( |  | ) | const

| Returns whether the part is selectable or not. Definition at line 214 of file part.cpp.

void KParts::Part::setWindowCaption | ( | const QString & | caption | ) | `[signal]`

| Emitted by the part, to set the caption of the window(s) hosting this part. Referenced by KParts::ReadOnlyPart::guiActivateEvent(), KParts::ReadOnlyPart::openURL(), and KParts::ReadWritePart::saveAs().

void KParts::Part::setStatusBarText | ( | const QString & | text | ) | `[signal]`

| Emited by the part, to set a text in the statusbar of the window(s) hosting this part.

void Part::setWidget | ( | QWidget * | widget | ) | `[protected, virtual]`

| Set the main widget. Call this in the Part-inherited class constructor. Definition at line 192 of file part.cpp. References KXMLGUIClient::actionCollection(), QObject::connect(), QObject::destroyed(), KActionCollection::setAutoConnectShortcuts(), and KActionCollection::setWidget().

void Part::partActivateEvent | ( | PartActivateEvent * | event | ) | `[protected, virtual]`

| Convenience method which is called when the Part received a PartActivateEvent . Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter. Definition at line 242 of file part.cpp.

void Part::partSelectEvent | ( | PartSelectEvent * | event | ) | `[protected, virtual]`

| Convenience method which is called when the Part received a PartSelectEvent . Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter. Definition at line 246 of file part.cpp.

void Part::guiActivateEvent | ( | GUIActivateEvent * | event | ) | `[protected, virtual]`

| Convenience method which is called when the Part received a GUIActivateEvent . Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter. Reimplemented in KParts::ReadOnlyPart. Definition at line 250 of file part.cpp.

QWidget * Part::hostContainer | ( | const QString & | containerName | ) | `[protected]`

| Convenience method for KXMLGUIFactory::container. Returns: a container widget owned by the Part's GUI. Definition at line 254 of file part.cpp. References KXMLGUIFactory::container(), and KXMLGUIClient::factory().

The documentation for this class was generated from the following files:

- part.h
- part.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:27:07 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001